org.python.core

## Class PyModule

- java.lang.Object
- - org.python.core.PyObject
  - - org.python.core.PyModule

All Implemented Interfaces:
  java.io.Serializable, Traverseproc

Direct Known Subclasses:
  PyModuleDerived

    public class PyModule
    extends PyObject
    implements Traverseproc

The Python Module object.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class org.python.core.PyObject

`PyObject.ConversionException`

### Field Summary

Fields
`PyObject` `__dict__` The module's mutable dictionary

### Fields inherited from class org.python.core.PyObject

`gcMonitorGlobal, TYPE`

### Constructor Summary

Constructors
Constructor and Description
`PyModule()`
`PyModule(PyType subType)`
`PyModule(PyType subType, java.lang.String name)`
`PyModule(java.lang.String name)`
`PyModule(java.lang.String name, PyObject dict)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `__delattr__(java.lang.String name)` A variant of the __delattr__ method which accepts a String as the key.
`PyObject` `__dir__()` Equivalent to the standard Python __dir__ method.
`PyObject` `__findattr_ex__(java.lang.String name)` Attribute lookup hook.
`void` `__setattr__(java.lang.String name, PyObject value)` A variant of the __setattr__ method which accepts a String as the key.
`void` `delDict()`
`PyObject` `fastGetDict()` xxx implements where meaningful
`PyObject` `getDict()` xxx implements where meaningful
`<T> T` `newJ(java.lang.Class<T> jcls, java.lang.Object... args)` Delegates to `Py.newJ(PyModule, Class, Object...)`.
`<T> T` `newJ(java.lang.Class<T> jcls, java.lang.String[] keywords, java.lang.Object... args)` Delgates to `Py.newJ(PyModule, Class, String[], Object...)`.
`boolean` `refersDirectlyTo(PyObject ob)` Optional operation.
`void` `setDict(PyObject newDict)`
`java.lang.String` `toString()`
`int` `traverse(Visitproc visit, java.lang.Object arg)` Traverses all directly contained `PyObject`s.

### Methods inherited from class org.python.core.PyObject

`__abs__, __add__, __and__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __cmp__, __coerce__, __coerce_ex__, __complex__, __contains__, __delattr__, __delete__, __delitem__, __delitem__, __delslice__, __delslice__, __div__, __divmod__, __ensure_finalizer__, __eq__, __findattr__, __findattr__, __finditem__, __finditem__, __finditem__, __float__, __floordiv__, __format__, __ge__, __get__, __getattr__, __getattr__, __getitem__, __getitem__, __getnewargs__, __getslice__, __getslice__, __gt__, __hash__, __hex__, __iadd__, __iand__, __idiv__, __idivmod__, __ifloordiv__, __ilshift__, __imod__, __imul__, __index__, __int__, __invert__, __ior__, __ipow__, __irshift__, __isub__, __iter__, __iternext__, __itruediv__, __ixor__, __le__, __len__, __long__, __lshift__, __lt__, __mod__, __mul__, __ne__, __neg__, __nonzero__, __not__, __oct__, __or__, __pos__, __pow__, __pow__, __radd__, __rand__, __rdiv__, __rdivmod__, __reduce__, __reduce_ex__, __reduce_ex__, __repr__, __rfloordiv__, __rlshift__, __rmod__, __rmul__, __ror__, __rpow__, __rrshift__, __rshift__, __rsub__, __rtruediv__, __rxor__, __set__, __setattr__, __setitem__, __setitem__, __setitem__, __setslice__, __setslice__, __str__, __sub__, __tojava__, __truediv__, __trunc__, __unicode__, __xor__, _add, _and, _callextra, _cmp, _div, _divmod, _doget, _doget, _doset, _eq, _floordiv, _ge, _gt, _iadd, _iand, _idiv, _idivmod, _ifloordiv, _ilshift, _imod, _imul, _in, _ior, _ipow, _irshift, _is, _isnot, _isub, _itruediv, _ixor, _jcall, _jcallexc, _jthrow, _le, _lshift, _lt, _mod, _mul, _ne, _notin, _or, _pow, _rshift, _sub, _truediv, _xor, asDouble, asIndex, asIndex, asInt, asInt, asIterable, asLong, asLong, asName, asName, asString, asString, asStringOrNull, asStringOrNull, bit_length, conjugate, delType, dispatch__init__, equals, fastGetClass, getType, hashCode, implementsDescrDelete, implementsDescrGet, implementsDescrSet, invoke, invoke, invoke, invoke, invoke, invoke, isCallable, isDataDescr, isIndex, isInteger, isMappingType, isNumberType, isSequenceType, noAttributeError, object___subclasshook__, readonlyAttributeError, setType`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### __dict__

    public PyObject __dict__

The module's mutable dictionary

### Constructor Detail

#### PyModule

    public PyModule()

#### PyModule

    public PyModule(PyType subType)

#### PyModule

    public PyModule(PyType subType,
                    java.lang.String name)

#### PyModule

    public PyModule(java.lang.String name)

#### PyModule

    public PyModule(java.lang.String name,
                    PyObject dict)

### Method Detail

#### fastGetDict

    public PyObject fastGetDict()

Description copied from class: `PyObject`
xxx implements where meaningful

Overrides:
  `fastGetDict` in class `PyObject`
Returns:
  internal object per instance dict or null

#### getDict

    public PyObject getDict()

Description copied from class: `PyObject`
xxx implements where meaningful

Overrides:
  `getDict` in class `PyObject`
Returns:
  internal object __dict__ or null

#### setDict

    public void setDict(PyObject newDict)

Overrides:
  `setDict` in class `PyObject`

#### delDict

    public void delDict()

Overrides:
  `delDict` in class `PyObject`

#### __findattr_ex__

    public PyObject __findattr_ex__(java.lang.String name)

Attribute lookup hook. If the attribute is not found, null may be returned or a Py.AttributeError can be thrown, whatever is more correct, efficient and/or convenient for the implementing class. Client code should use `PyObject.__getattr__(String)` or `PyObject.__findattr__(String)`. Both methods have a clear policy for failed lookups.

Overridden in `PyModule` so that if the base-class `__findattr_ex__` is unsuccessful, it will to search for the named attribute as a Java sub-package. This is responsible for the automagical import of Java (but not Python) packages when referred to as attributes.

Overrides:
  `__findattr_ex__` in class `PyObject`
Returns:
  The looked up value. May return null if the attribute is not found

#### __setattr__

    public void __setattr__(java.lang.String name,
                            PyObject value)

Description copied from class: `PyObject`
A variant of the __setattr__ method which accepts a String as the key. This String must be interned.

Overrides:
  `__setattr__` in class `PyObject`
Parameters:
  `name` - the name whose value will be set - must be an interned string .
  `value` - the value to set this name to
See Also:
  `PyObject.__setattr__(PyString, PyObject)`

#### __delattr__

    public void __delattr__(java.lang.String name)

Description copied from class: `PyObject`
A variant of the __delattr__ method which accepts a String as the key. This String must be interned. By default, this will call `__delattr__(PyString name)` with the appropriate args. The only reason to override this method is for performance.

Overrides:
  `__delattr__` in class `PyObject`
Parameters:
  `name` - the name which will be removed - must be an interned string .
See Also:
  `PyObject.__delattr__(PyString)`

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `PyObject`

#### __dir__

    public PyObject __dir__()

Description copied from class: `PyObject`
Equivalent to the standard Python __dir__ method.

Overrides:
  `__dir__` in class `PyObject`
Returns:
  a list of names defined by this object.

#### newJ

    public <T> T newJ(java.lang.Class<T> jcls,
                      java.lang.Object... args)

Delegates to `Py.newJ(PyModule, Class, Object...)`. For keyword support use `newJ(Class, String[], Object...)`.

Parameters:
  `jcls` - Java-type of the desired clas, must have the same name
  `args` - constructor-arguments
Returns:
  a new instance of the desired class
See Also:
  `newJ(Class, String[], Object...)`, `Py.newJ(PyModule, Class, String[], Object...)`, `Py.newJ(PyObject, Class, PyObject[], String[])`, `Py.newJ(PyObject, Class, Object...)`, `Py.newJ(PyObject, Class, String[], Object...)`

#### newJ

    public <T> T newJ(java.lang.Class<T> jcls,
                      java.lang.String[] keywords,
                      java.lang.Object... args)

Delgates to `Py.newJ(PyModule, Class, String[], Object...)`. `keywords` are applied to the last `args` in the list.

Parameters:
  `jcls` - Java-type of the desired class, must have the same name
  `keywords` - are applied to the last `args` in the list
  `args` - constructor-arguments
Returns:
  a new instance of the desired class
See Also:
  `newJ(Class, Object...)`, `Py.newJ(PyModule, Class, String[], Object...)`, `Py.newJ(PyObject, Class, PyObject[], String[])`, `Py.newJ(PyObject, Class, Object...)`, `Py.newJ(PyObject, Class, String[], Object...)`

#### traverse

    public int traverse(Visitproc visit,
                        java.lang.Object arg)

Description copied from interface: `Traverseproc`
Traverses all directly contained `PyObject`s. Like in CPython, `arg` must be passed unmodified to `visit` as its second parameter. If `Visitproc.visit(PyObject, Object)` returns nonzero, this return value must be returned immediately by traverse. `Visitproc.visit(PyObject, Object)` must not be called with a `null` PyObject-argument.

Specified by:
  `traverse` in interface `Traverseproc`

#### refersDirectlyTo

    public boolean refersDirectlyTo(PyObject ob)

Description copied from interface: `Traverseproc`
Optional operation. Should only be implemented if it is more efficient than calling `Traverseproc.traverse(Visitproc, Object)` with a visitproc that just watches out for `ob`. Must return `false` if `ob` is `null`.

Specified by:
  `refersDirectlyTo` in interface `Traverseproc`